#include "arduinoFFT.h"       // pouziti knihovny
arduinoFFT FFT = arduinoFFT();// spusti knihovnu

const uint16_t samples = 1024; 
const double signalFrequency = 1000;
const double samplingFrequency = 1000;
const uint8_t amplitude = 100; 
unsigned long cas2;
double valuesVoltageArr[samples];
double valuesVoltageArr_img[samples];
double adcValue;
int i=0;


#define SCL_INDEX 0x00
#define SCL_TIME 0x01
#define SCL_FREQUENCY 0x02
#define SCL_PLOT 0x03

void setup()
{
  Serial.begin(115200);    
  Serial.println("Ready");
  analogReadResolution(12);
}

void loop()
{
  adcValue = analogRead(A0);    
if (abs((micros()-cas2))>=1000)
  {
  cas2=micros();
  valuesVoltageArr[i]=adcValue * (3.3 / 4095.0);;
  valuesVoltageArr_img[i]=0;
  i=i+1;
  }
  if (i==samples)
  {  
  Serial.println("Data:");
  PrintVector(valuesVoltageArr, samples, SCL_TIME);

   FFT.Windowing(valuesVoltageArr, samples, FFT_WIN_TYP_RECTANGLE, FFT_FORWARD);  /* Weigh data */
     Serial.println("vážená data:");
     PrintVector(valuesVoltageArr, samples, SCL_TIME);
   FFT.Compute(valuesVoltageArr, valuesVoltageArr_img, samples, FFT_FORWARD); /* Compute FFT */ 
      Serial.println("spocitane Real values:");
      PrintVector(valuesVoltageArr, samples, SCL_INDEX);
   FFT.ComplexToMagnitude(valuesVoltageArr, valuesVoltageArr_img, samples); /* Compute magnitudes */
       Serial.println("Computed magnitudes:");
       PrintVector_frekv(valuesVoltageArr, (samples >> 1));
   double x = FFT.MajorPeak(valuesVoltageArr, samples, samplingFrequency);
     Serial.println(x, 6);
  i=0;
   while(1);
  }
}
  
void PrintVector(double *vData, uint16_t bufferSize, uint8_t scaleType)
{
  for (uint16_t i = 0; i < bufferSize; i++)
  {
   double abscissa;
    /* Print abscissa value */
    switch (scaleType)
       {
      case SCL_INDEX:
        abscissa = (i * 1.0);
	break;
      case SCL_TIME:
        abscissa = ((i * 1.0) / samplingFrequency);
	break;
      case SCL_FREQUENCY:
        abscissa = ((i * 1.0 * samplingFrequency) / samples);
	break;
        }
    Serial.print(abscissa, 6);
    if(scaleType==SCL_FREQUENCY)
     Serial.print("Hz");
     Serial.print(" ");
     Serial.println(vData[i], 4);
     
 }

}

void PrintVector_frekv(double *vData, uint16_t bufferSize)
{
  int hodnota;
  for (uint16_t i = 0; i < bufferSize; i++)
    {
      if (i==0)
      {
      hodnota=1;
      }
      else
      {
      hodnota=2;
      } 
    double abscissa;
    /* Print abscissa value */
        abscissa = ((i * 1.0 * samplingFrequency) / samples);
     Serial.print(abscissa, 6);
     Serial.print("Hz");
     Serial.print(" ");
     Serial.println(hodnota*vData[i]/samples, 4);
     
 }
}
